open import Lib.Equality as Eq using (_==_ ; auto)
open import Lib.Maybe
open import Lib.Boolean
open import Lib.Proposition
open import Lib.List
open import Lib.Word
open import Lib.Word-Lemmas
open import Lib.Word-Tactics

open Monoid-Equational
open Rewriting
open Associative
open InContext

open import Lib.MaybeEq
open import Lib.MaybeEq-Instances
open import CosetNF
open import Gate

open import Step5.Rel
open import Step5.S8
open import Step5.Comm
open import Step5.Order

module Step5.Basis-Change where
  lemma-Swap12-CCX2=CCX1-Swap12 : Rel ⊢ Swap12 • CCX2 === CCX1 • Swap12
  lemma-Swap12-CCX2=CCX1-Swap12 = ListNF.listnfeq' nf-s7e auto

  lemma-Swap12-CCX1=CCX2-Swap12 : Rel ⊢ Swap12 • CCX1 === CCX2 • Swap12
  lemma-Swap12-CCX1=CCX2-Swap12 = ListNF.listnfeq' nf-s7e auto

  lemma-Swap12-CX01=CX02-Swap12 : Rel ⊢ Swap12 • CX01 === CX02 • Swap12
  lemma-Swap12-CX01=CX02-Swap12 = ListNF.listnfeq' nf-s7e auto
  
  lemma-Swap12-CX02=CX01-Swap12 : Rel ⊢ Swap12 • CX02 === CX01 • Swap12
  lemma-Swap12-CX02=CX01-Swap12 = ListNF.listnfeq' nf-s7e auto

  mvSwap12-step : Step-Function Gate Rel
  mvSwap12-step (Swap12-gen :: Swap12-gen :: xs) = Just (xs , at-head (axiom ax-Swap12-Swap12=ε))
  mvSwap12-step (Swap12-gen :: K0-gen :: xs) = Just (K0-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-K0=K0-Swap12))
  mvSwap12-step (Swap12-gen :: CCX0-gen :: xs) = Just (CCX0-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-CCX0=CCX0-Swap12))
  mvSwap12-step (Swap12-gen :: CCX2-gen :: xs) = Just (CCX1-gen :: Swap12-gen :: xs , at-head lemma-Swap12-CCX2=CCX1-Swap12)
  mvSwap12-step (Swap12-gen :: CCX1-gen :: xs) = Just (CCX2-gen :: Swap12-gen :: xs , at-head lemma-Swap12-CCX1=CCX2-Swap12)
  mvSwap12-step (Swap12-gen :: CS01-gen :: xs) = Just (CS02-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-CS01=CS02-Swap12))
  mvSwap12-step (Swap12-gen :: CS12-gen :: xs) = Just (CS12-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-CS12=CS12-Swap12))
  mvSwap12-step (Swap12-gen :: CS02-gen :: xs) = Just (CS01-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-CS02=CS01-Swap12))
  mvSwap12-step (Swap12-gen :: S0-gen :: xs) = Just (S0-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-S0=S0-Swap12))
  mvSwap12-step (Swap12-gen :: S1-gen :: xs) = Just (S2-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-S1=S2-Swap12))
  mvSwap12-step (Swap12-gen :: S2-gen :: xs) = Just (S1-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-S2=S1-Swap12))
  mvSwap12-step (Swap12-gen :: iI-gen :: xs) = Just (iI-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-iI=iI-Swap12))
  mvSwap12-step (Swap12-gen :: CX01-gen :: xs) = Just (CX02-gen :: Swap12-gen :: xs , at-head lemma-Swap12-CX01=CX02-Swap12)
  mvSwap12-step (Swap12-gen :: CX02-gen :: xs) = Just (CX01-gen :: Swap12-gen :: xs , at-head lemma-Swap12-CX02=CX01-Swap12)
  mvSwap12-step (Swap12-gen :: CX10-gen :: xs) = Just (CX20-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-CX10=CX20-Swap12))
  mvSwap12-step (Swap12-gen :: CX20-gen :: xs) = Just (CX10-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-CX20=CX10-Swap12))
  mvSwap12-step (Swap12-gen :: CX12-gen :: xs) = Just (CX21-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-CX12=CX21-Swap12))
  mvSwap12-step (Swap12-gen :: CX21-gen :: xs) = Just (CX12-gen :: Swap12-gen :: xs , at-head (axiom ax-Swap12-CX21=CX12-Swap12))
  mvSwap12-step _ = Nothing

  module MvSwap12 = Rewriting.Step (step-cong mvSwap12-step)

  open Basis-Change2 mvSwap12-step public
